#define _XTAL_FREQ 32000000

#define DandanatorMiniFWBank 1                                                  // Bank Number for Dandanator Mini Firmware (1-33)
#define AutoBootBank 2                                                          // AutoBoot Bank
#define ExtraROMBank 32                                                         // Bank Number for Extra ROM (1-33)
#define InternalROMBank 33                                                      // Internal ROM (1-33)
#define PreviousROMBank 35                                                      // Selection for previous bank 
#define Reset_Hold_Time_ms 200                                                  // Time (ms) to hold Spectrum in Reset


#define EE_ExtraRom_CMDAllowed1 251                                             // Eeprom Addresses
#define EE_ExtraRom_CMDAllowed2 252
#define EE_NormalBoot 253                                                       
#define EE_ForcedROM_Switch1 254
#define EE_ForcedROM_Switch2 255

#define SW1 0                                                                   // Switch Control aliases
#define SW2 1
#define Short 0
#define Long 1
#define Double 2

#define Switch1 PORTBbits.RB1                                                   // Switch 1
#define Switch2 PORTBbits.RB2                                                   // Switch 2
#define nResetPort PORTBbits.RB6                                                // Spectrum Reset Line (Read)

#define Z80_nReset() LATBbits.LATB6=0;TRISBbits.TRISB6=0
#define Z80_nReset_Hold() LATBbits.LATB6=0;TRISBbits.TRISB6=0;__delay_ms(Reset_Hold_Time_ms) // ensure minimum time for reset pulse
#define Z80_nReset_Release() TRISBbits.TRISB6=1
#define Z80_Send_Reset() Z80_nReset_Hold();Z80_nReset_Release()
#define Z80_nNMI_Enable() LATBbits.LATB7=0;TRISBbits.TRISB7=0
#define Z80_nNMI_Disable() TRISBbits.TRISB7=1
#define Z80_Send_NMI() Z80_nNMI_Enable();NOP();NOP();Z80_nNMI_Disable()
#define Disable_Dandanator_Commands() SpectrumCommandStatus=Commands_Disabled;INTE=0

bool ChangeSlotOnReset = false;                                                 // Software Flag activated if Command 39 is received. 
unsigned char ResetSlot = 1;                                                    // Slot to change to if Reset is detected and ChageSlotOnReset is true
unsigned char PreviousSlot;                                                     // Active Slot when Pause button was pressed