//#include <xc.h>
#include <stdbool.h>

#define TMR0InitValue 255                                                       // TMR0 Hardware Counter for 32us @ 32mhz and 1:256ps (was 128us, 252)
#define TMR0SpecialAllowanceInitValue  240                                      // TMR0 Hardware Counter for 512us @ 32mhz and 1:256ps (was 5ms, 100)

#define TMR1InitValueH 59                                                       // TMR1 Hardware Counter to 50ms int @32mhz and prescaler 1:8
#define TMR1InitValueL 224                                                      // 
#define TMR1SWPostScaler 6                                                      // TMR1 Software postscaler value for ~300ms @ 32Mhz
#define TMR2InitValue 255                                                       // TMR2 Hardware Counter for ~8ms @32Mhz
#define TMR2SWPostScaler 120                                                    // TMR2 Software postscaler value for ~1 second trigger @ 32Mhz


typedef enum                                                                    // State Machine for incoming communications from Spectrum
{
  Commands_Disabled,
  Commands_Locked, 
  Wait_Normal, 
  In_Progress_Normal,
  In_Progress_Locked,
  In_Progress_Special_Data1,
  In_Progress_Special_Data2,
  In_Progress_Fast,
  Pending_Processing,
} ZXCmdStateMachine;
                                
typedef enum                                                                    // Type of actions that a switch can perform
{
  Switch_Disabled=0,
  Select_RomN_RESET=1,
  Select_RomN_NMI_Enable_Commands=2,
  RESET=3,
  NMI=4,
 // Lock_Commands=5, // DISABLED
 // Disable_Commands=6, // DISABLED
  Select_RomN_RESET_Enable_Unlock_Commands=7,
  Next_Rom_RESET=8                                                              // Actually "previous rom slo & Reset"
} Switch_Action;  

typedef struct                                                                  // Associate Switch Actions to Bank Numbers
{
 Switch_Action action;
 unsigned char BankN;
} Switch_Control;
                           

bool LongSwitchPressedFlag = false;                                             // Software Flag - Long Switch 1 push
bool ShortSwitchPressedFlag = false;                                            // Software Flag - Short Switch 1 push
bool DoubleSwitchPressedFlag = false;                                           // Software Flag - Double Switch 1 "click"
bool Switch2PressedFlag = false;                                                // Software Flag - Button 2 click (button 2 only has 1 action)


Switch_Control Switches[2][3];                                                  // Variable for Controlling Switch Actions (2 Switches, 3 actions -> Short, Long, Double click- 
                                                                                // Note: Switch 2 only respond to 1 short click action, no timers left.

ZXCmdStateMachine SpectrumCommandStatus = Wait_Normal;                          // ZX Command Reception State Machine, wait for normal command 

unsigned char SpectrumCommandCounter = 0;                                       // Counter for Command Detection
unsigned char SpectrumData1Counter = 0;                                         // Counter for Special Command Data 1
unsigned char SpectrumData2Counter = 0;                                         // Counter for Special Command Data 2

bool ReadEepromFlag = false;                                                    // Eeprom must be read from main thread. Flag, Address & value
bool ModifyEepromFlag = false;                                                  // Eeprom must be modified from main thread. Flag, Address & value
unsigned char EepromAddress;
unsigned char ModifyEepromValue;


extern void Interrupt_Handler();
