
/*************************************************************************
*                                DEFINES
*************************************************************************/
// In this PIC, all is Word related
#define FLASHSTORAGEPOSITION    0x0200                                          // Define Flash Storage position (Aligned 64 words) 512 -> 1024 bytes
#define FLASHSIZE               0x0800-FLASHSTORAGEPOSITION                     // FLASHSIZE of main program            
#define FLASHCHUNKSIZE          4                                               // Flash Chunk Size (Write Latches)
#define FLASHSEGMENTSIZE        16                                              // Flash Segment Size (Erase)

#define NCHUNKS                 384                                             // Number of Chunks to write = FLASHSIZE / FLASHCHUNKSIZE
#define NSEGMENTS               96                                              // Number of Segments to erase = FLASHSIZE / FLASHSEGMENTSIZE

#define ISR_OFFSET              0x04                                            // Offset for interrupt vector in Main Program



/*************************************************************************
*                          PUBLIC CONSTS & VARS
*************************************************************************/

unsigned char FlashBuffer[FLASHCHUNKSIZE*2];                                    // Flash Operations buffer


/*************************************************************************
*                            PUBLIC FUNCTIONS
*************************************************************************/

extern void Save_Flash_Chunk(unsigned short ChunkN, unsigned char* VChunk);     // Saves Flash Chunk from RAM Buffer (Size 8 bytes)
extern void Erase_Flash_Segment(unsigned short SegmentN);                       // Erases Flash Segment (size 32 bytes)